searchNodes=[{"type":"module","title":"HtmlQuery","doc":"Some simple HTML query functions. Delegates the hard work to Floki . Data types All functions accept HTML in the form of a string, a Floki HTML tree, or a Floki HTML node. Others expect only a Floki HTML node or a Floki HTML tree. See HtmlQuery.html/0 . Some functions take a CSS selector, which can be a string, a keyword list, or a list. See HtmlQuery.Css.selector/0 . Main query functions The main query functions take an HTML string or some parsed HTML, and a selector. all/2 return all elements matching the selector find/2 return the first element that matches the selector find!/2 return the only element that matches the selector Extraction functions attr/2 returns the attribute value as a string form_fields/1 returns the names and values of form fields as a map meta_tags/1 returns the names and values of metadata fields table/2 returns the cells of a table as a list of lists text/1 returns the text contents as a single string Parsing functions parse/1 parses an HTML fragment into a [Floki HTML tree] parse_doc/1 parses an HTML doc into a [Floki HTML tree] Utility functions inspect_html/2 prints prettified HTML with a label normalize/1 parses and re-stringifies HTML pretty/1 prettifies HTML reject/2 removes nodes that match the selector Alias If you use HtmlQuery a lot, you may want to alias it to the recommended shortcut &quot;Hq&quot;: alias HtmlQuery , as : Hq Examples Get the value of a selected option: iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . find ( html , &quot;select option[selected]&quot; ) |&gt; HtmlQuery . attr ( &quot;value&quot; ) &quot;a&quot; Get the text of a selected option, raising if there are more than one: iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . find! ( html , &quot;select option[selected]&quot; ) |&gt; HtmlQuery . text ( ) &quot;apples&quot; Get the text of all the options: iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . all ( html , &quot;select option&quot; ) |&gt; Enum . map ( &amp; HtmlQuery . text / 1 ) [ &quot;apples&quot; , &quot;bananas&quot; ] Use a keyword list as the selector (see HtmlQuery.Css for details on selectors): iex&gt; html = ~s|&lt;div&gt; &lt;a href=&quot;/logout&quot; test-role=&quot;logout-link&quot;&gt;logout&lt;/a&gt; &lt;/div&gt;| iex&gt; HtmlQuery . find! ( html , test_role : &quot;logout-link&quot; ) |&gt; HtmlQuery . attr ( &quot;href&quot; ) &quot;/logout&quot;","ref":"HtmlQuery.html"},{"type":"function","title":"HtmlQuery.all/2","doc":"Finds all elements in html that match selector , returning a Floki HTML tree. iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . all ( html , &quot;option&quot; ) [ { &quot;option&quot; , [ { &quot;value&quot; , &quot;a&quot; } , { &quot;selected&quot; , &quot;selected&quot; } ] , [ &quot;apples&quot; ] } , { &quot;option&quot; , [ { &quot;value&quot; , &quot;b&quot; } ] , [ &quot;bananas&quot; ] } ]","ref":"HtmlQuery.html#all/2"},{"type":"function","title":"HtmlQuery.attr/2","doc":"Returns the value of attr from the outermost element of html . If attr is an atom, any underscores are converted to dashes. iex&gt; html = ~s|&lt;div&gt; &lt;a href=&quot;/logout&quot; test-role=&quot;logout-link&quot;&gt;logout&lt;/a&gt; &lt;/div&gt;| iex&gt; HtmlQuery . find! ( html , test_role : &quot;logout-link&quot; ) |&gt; HtmlQuery . attr ( &quot;href&quot; ) &quot;/logout&quot;","ref":"HtmlQuery.html#attr/2"},{"type":"function","title":"HtmlQuery.find/2","doc":"Finds the first element in html that matches selector , returning a Floki HTML node. iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . find ( html , &quot;select option[selected]&quot; ) { &quot;option&quot; , [ { &quot;value&quot; , &quot;a&quot; } , { &quot;selected&quot; , &quot;selected&quot; } ] , [ &quot;apples&quot; ] }","ref":"HtmlQuery.html#find/2"},{"type":"function","title":"HtmlQuery.find!/2","doc":"Like find/2 but raises unless exactly one element is found.","ref":"HtmlQuery.html#find!/2"},{"type":"function","title":"HtmlQuery.form_fields/1","doc":"Returns a map containing the form fields of form selector in html . Because it returns a map, any information about the order of form fields is lost. iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;text&quot; name=&quot;color&quot; value=&quot;green&quot;&gt; &lt;textarea name=&quot;desc&quot;&gt;A tree&lt;/textarea&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ color : &quot;green&quot; , desc : &quot;A tree&quot; } Field names are converted to snake case atoms: iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;text&quot; name=&quot;favorite-color&quot; value=&quot;green&quot;&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ favorite_color : &quot;green&quot; } If form field names are in foo[bar] format, then foo becomes a key to a nested map containing bar : iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;text&quot; name=&quot;profile[name]&quot; value=&quot;fido&quot;&gt; &lt;input type=&quot;text&quot; name=&quot;profile[age]&quot; value=&quot;10&quot;&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ profile : %{ name : &quot;fido&quot; , age : &quot;10&quot; } } If a text field has no value attribute, it will not be returned at all: iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;text&quot; name=&quot;no-value&quot;&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ } iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;text&quot; name=&quot;empty-value&quot; value=&quot;&quot;&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ empty_value : &quot;&quot; } iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;text&quot; name=&quot;non-empty-value&quot; value=&quot;something&quot;&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ non_empty_value : &quot;something&quot; } The checked value of a radio button set is returned, or nil is returned if no value is checked: iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;radio&quot; name=&quot;x&quot; value=&quot;1&quot;&gt; &lt;input type=&quot;radio&quot; name=&quot;x&quot; value=&quot;2&quot; checked&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ x : &quot;2&quot; } iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;radio&quot; name=&quot;x&quot; value=&quot;1&quot;&gt; &lt;input type=&quot;radio&quot; name=&quot;x&quot; value=&quot;2&quot;&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ x : nil } All checked values of checkboxes are returned as a list, or [] is returned if no values are checked: iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;checkbox&quot; name=&quot;x&quot; value=&quot;1&quot; checked&gt; &lt;input type=&quot;checkbox&quot; name=&quot;x&quot; value=&quot;2&quot; checked&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ x : [ &quot;1&quot; , &quot;2&quot; ] } iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;checkbox&quot; name=&quot;x&quot; value=&quot;1&quot;&gt; &lt;input type=&quot;checkbox&quot; name=&quot;x&quot; value=&quot;2&quot;&gt; &lt;/form&gt;| iex&gt; html |&gt; HtmlQuery . find ( &quot;form&quot; ) |&gt; HtmlQuery . form_fields ( ) %{ x : [ ] }","ref":"HtmlQuery.html#form_fields/1"},{"type":"function","title":"HtmlQuery.inspect_html/2","doc":"Prints prettified html with a label, and then returns the original html.","ref":"HtmlQuery.html#inspect_html/2"},{"type":"function","title":"HtmlQuery.meta_tags/1","doc":"Extracts all the meta tags from html , returning a list of maps. iex&gt; html = ~s|&lt;head&gt; &lt;meta charset=&quot;utf-8&quot;/&gt; &lt;meta http-equiv=&quot;X-UA-Compatible&quot; content=&quot;IE=edge&quot;/&gt; &lt;/head&gt;| iex&gt; HtmlQuery . meta_tags ( html ) [ %{ &quot;charset&quot; =&gt; &quot;utf-8&quot; } , %{ &quot;content&quot; =&gt; &quot;IE=edge&quot; , &quot;http-equiv&quot; =&gt; &quot;X-UA-Compatible&quot; } ]","ref":"HtmlQuery.html#meta_tags/1"},{"type":"function","title":"HtmlQuery.normalize/1","doc":"Parses and then re-stringifies html , increasing the liklihood that two equivalent HTML strings can be considered equal. iex&gt; a = ~s|&lt;p id=&quot;color&quot;&gt;green&lt;/p&gt;| iex&gt; b = ~s|&lt;p id = &quot;color&quot; &gt;green&lt;/p&gt;| iex&gt; a == b false iex&gt; HtmlQuery . normalize ( a ) == HtmlQuery . normalize ( b ) true","ref":"HtmlQuery.html#normalize/1"},{"type":"function","title":"HtmlQuery.parse/1","doc":"Parses an HTML fragment using Floki.parse_fragment!/1 , returning a Floki HTML tree.","ref":"HtmlQuery.html#parse/1"},{"type":"function","title":"HtmlQuery.parse_doc/1","doc":"Parses an HTML document using Floki.parse_document!/1 , returning a Floki HTML tree.","ref":"HtmlQuery.html#parse_doc/1"},{"type":"function","title":"HtmlQuery.pretty/1","doc":"Returns html as a prettified string (delgates to Floki.raw_html/2 with the pretty: true option).","ref":"HtmlQuery.html#pretty/1"},{"type":"function","title":"HtmlQuery.reject/2","doc":"Returns html after removing all nodes that don't match selector (delegates to Floki.filter_out/2 ). iex&gt; html = ~s|&lt;div&gt; &lt;span id=&quot;name&quot;&gt;Alice&lt;/span&gt; &lt;span id=&quot;password&quot;&gt;topaz&lt;/span&gt; &lt;/div&gt;| iex&gt; HtmlQuery . reject ( html , id : &quot;password&quot; ) |&gt; HtmlQuery . normalize ( ) ~s|&lt;div&gt;&lt;span id=&quot;name&quot;&gt;Alice&lt;/span&gt;&lt;/div&gt;|","ref":"HtmlQuery.html#reject/2"},{"type":"function","title":"HtmlQuery.table/2","doc":"Returns the contents of the table as a list of lists. Options: as - if :lists (the default), returns the table as a list of lists; if :maps , returns the table as a list of maps. columns - a list of the indices of the columns to return; a list of column headers (as strings) to return, assuming that the first row of the table is the columns names; or :all to return all columns (which is the same as not specifying this option all all). headers - if true (the default), returns the list of headers along with the rows. Ignored if as option is :map . iex&gt; html = &quot;&lt;table&gt; &lt;tr&gt;&lt;th&gt;A&lt;/th&gt;&lt;th&gt;B&lt;/th&gt;&lt;th&gt;C&lt;/th&gt;&lt;/tr&gt; &lt;tr&gt;&lt;td&gt;1&lt;/td&gt;&lt;td&gt;2&lt;/td&gt;&lt;td&gt;3&lt;/td&gt;&lt;/tr&gt; &lt;/table&gt;&quot; iex&gt; HtmlQuery . table ( html ) [ [ &quot;A&quot; , &quot;B&quot; , &quot;C&quot; ] , [ &quot;1&quot; , &quot;2&quot; , &quot;3&quot; ] ] iex&gt; HtmlQuery . table ( html , as : :maps ) [ %{ &quot;A&quot; =&gt; &quot;1&quot; , &quot;B&quot; =&gt; &quot;2&quot; , &quot;C&quot; =&gt; &quot;3&quot; } ] iex&gt; HtmlQuery . table ( html , columns : [ 0 , 2 ] ) [ [ &quot;A&quot; , &quot;C&quot; ] , [ &quot;1&quot; , &quot;3&quot; ] ] iex&gt; HtmlQuery . table ( html , columns : [ 2 , 0 ] ) [ [ &quot;C&quot; , &quot;A&quot; ] , [ &quot;3&quot; , &quot;1&quot; ] ] iex&gt; HtmlQuery . table ( html , columns : [ &quot;C&quot; , &quot;A&quot; ] ) [ [ &quot;C&quot; , &quot;A&quot; ] , [ &quot;3&quot; , &quot;1&quot; ] ] iex&gt; HtmlQuery . table ( html , columns : [ &quot;C&quot; , &quot;A&quot; ] , headers : false ) [ [ &quot;3&quot; , &quot;1&quot; ] ]","ref":"HtmlQuery.html#table/2"},{"type":"function","title":"HtmlQuery.text/1","doc":"Returns the text value of html . iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; HtmlQuery . find! ( html , &quot;select option[selected]&quot; ) |&gt; HtmlQuery . text ( ) &quot;apples&quot;","ref":"HtmlQuery.html#text/1"},{"type":"type","title":"HtmlQuery.attr/0","doc":"A string or atom representing an attribute name. If an atom, underscores are converted to dashes.","ref":"HtmlQuery.html#t:attr/0"},{"type":"type","title":"HtmlQuery.html/0","doc":"A string, a struct that implements the String.Chars protocol, a Floki HTML tree , or a Floki HTML node .","ref":"HtmlQuery.html#t:html/0"},{"type":"module","title":"HtmlQuery.Css","doc":"Constructs CSS selectors via Elixir data structures. See selector/1 for details.","ref":"HtmlQuery.Css.html"},{"type":"function","title":"HtmlQuery.Css.selector/1","doc":"Accepts a string, atom, keyword list, or list, and returns a CSS string. String syntax When given a string, returns the string. This is useful when you don't know if a selector is already a string. iex&gt; HtmlQuery.Css . selector ( &quot;.profile[test-role=&#39;new-members&#39;]&quot; ) &quot;.profile[test-role=&#39;new-members&#39;]&quot; Atom syntax When given an atom, converts the atom to a string, without converting underscores to dashes. iex&gt; HtmlQuery.Css . selector ( :p ) &quot;p&quot; Keyword list syntax The keyword list syntax is intentionally limited; complex selectors are more easily written as strings. The keyword list syntax makes it a bit eaiser to write simple selectors or selectors that use variables: e.g.: HtmlQuery.Css . selector ( test_role : &quot;new-members&quot; ) HtmlQuery.Css . selector ( id : some_variable ) Keys are expected to be atoms and will be dasherized ( foo_bar -&gt; foo-bar ). Values are expected to be strings or another keyword list. A key/value pair will be converted to an attribute selector: iex&gt; HtmlQuery.Css . selector ( test_role : &quot;new-members&quot; ) &quot;[test-role=&#39;new-members&#39;]&quot; A keyword list will be converted to a list of attribute selectors: iex&gt; HtmlQuery.Css . selector ( class : &quot;profile&quot; , test_role : &quot;new-members&quot; ) &quot;[class=&#39;profile&#39;][test-role=&#39;new-members&#39;]&quot; (Note that the CSS selector .profile expands to [class~='profile'] which is not equivalent to [class='profile'] . The keyword list syntax will not generate ~= selectors so you should use a string selector such as &quot;.profile[test-role='new-members']&quot; instead if you want ~= semantics. See the CSS spec for details.) When the value is a keyword list, the key is converted to an element selector: iex&gt; HtmlQuery.Css . selector ( p : [ class : &quot;profile&quot; , test_role : &quot;new-members&quot; ] ) &quot;p[class=&#39;profile&#39;][test-role=&#39;new-members&#39;]&quot; List syntax The list syntax is intentionally limited; complex selectors are more easily written as strings. When the value is a list (vs a keyword list), atoms are converted to element selectors and keyword lists are converted as described above. iex&gt; HtmlQuery.Css . selector ( [ [ p : [ class : &quot;profile&quot; , test_role : &quot;new-members&quot; ] ] , :div , [ class : &quot;tag&quot; ] ] ) &quot;p[class=&#39;profile&#39;][test-role=&#39;new-members&#39;] div [class=&#39;tag&#39;]&quot;","ref":"HtmlQuery.Css.html#selector/1"},{"type":"type","title":"HtmlQuery.Css.selector/0","doc":"See docs for selector/1 for more details.","ref":"HtmlQuery.Css.html#t:selector/0"},{"type":"module","title":"HtmlQuery.Form","doc":"Form-handling functions. Most of the time, HtmlQuery.form_fields/1 should be used instead of calling these functions directly.","ref":"HtmlQuery.Form.html"},{"type":"function","title":"HtmlQuery.Form.fields/1","doc":"","ref":"HtmlQuery.Form.html#fields/1"},{"type":"exception","title":"HtmlQuery.QueryError","doc":"An exception raised when unable to find an HTML element.","ref":"HtmlQuery.QueryError.html"},{"type":"extras","title":"HtmlQuery","doc":"Some simple HTML query functions. Delegates the hard work to Floki . iex&gt; alias HtmlQuery , as : Hq iex&gt; html = &quot;&quot;&quot; &lt;form id=&quot;profile&quot; test-role=&quot;profile&quot;&gt; &lt;label&gt;Name &lt;input name=&quot;name&quot; type=&quot;text&quot; value=&quot;Fido&quot;&gt; &lt;/label&gt; &lt;label&gt;Age &lt;input name=&quot;age&quot; type=&quot;text&quot; value=&quot;10&quot;&gt; &lt;/label&gt; &lt;label&gt;Bio &lt;textarea name=&quot;bio&quot;&gt;Fido likes long walks and playing fetch.&lt;/textarea&gt; &lt;/label&gt; &lt;/form&gt; &lt;/form&gt; &quot;&quot;&quot; iex&gt; html |&gt; Hq . find! ( test_role : &quot;profile&quot; ) { &quot;form&quot; , [ { &quot;id&quot; , &quot;profile&quot; } , { &quot;test-role&quot; , &quot;profile&quot; } ] , [ { &quot;label&quot; , [ ] , [ &quot;Name &quot; , { &quot;input&quot; , [ { &quot;name&quot; , &quot;name&quot; } , { &quot;type&quot; , &quot;text&quot; } , { &quot;value&quot; , &quot;Fido&quot; } ] , [ ] } ] } , { &quot;label&quot; , [ ] , [ &quot;Age &quot; , { &quot;input&quot; , [ { &quot;name&quot; , &quot;age&quot; } , { &quot;type&quot; , &quot;text&quot; } , { &quot;value&quot; , &quot;10&quot; } ] , [ ] } ] } , { &quot;label&quot; , [ ] , [ &quot;Bio &quot; , { &quot;textarea&quot; , [ { &quot;name&quot; , &quot;bio&quot; } ] , [ &quot;Fido likes long walks and playing fetch.&quot; ] } ] } ] } iex&gt; html |&gt; Hq . all ( &quot;input[type=text]&quot; ) |&gt; Enum . map ( &amp; Hq . attr ( &amp;1 , &quot;value&quot; ) ) [ &quot;Fido&quot; , &quot;10&quot; ] iex&gt; html |&gt; Hq . find ( test_role : &quot;profile&quot; ) |&gt; Hq . form_fields ( ) %{ age : &quot;10&quot; , bio : &quot;Fido likes long walks and playing fetch.&quot; , name : &quot;Fido&quot; }","ref":"readme.html"},{"type":"extras","title":"HtmlQuery - API Docs","doc":"See the documentation for the main HtmlQuery module for details and more examples: https://hexdocs.pm/html_query/HtmlQuery.html","ref":"readme.html#api-docs"},{"type":"extras","title":"HtmlQuery - Installation","doc":"def deps do [ { :html_query , &quot;~&gt; 1.2&quot; } ] end","ref":"readme.html#installation"},{"type":"extras","title":"LICENSE","doc":"Copyright 2022 synchronal.dev Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}]